<?php
/*
Plugin Name: fun-with-photo-data
Plugin URI: http://www.wp-fun.co.uk/2008/04/02/wordpress-25-exif-fields/
Description: Adds a shortcode to display the EXIF and IPTC Data that WordPress 2.5 extracts.
Author: Andrew Rickmann
Version: 0.1
Author URI: http://www.wp-fun.co.uk
Generated At: www.wp-fun.co.uk;
*/ 

/*  Copyright 2008  Andrew Rickmann  (email : PLUGIN AUTHOR EMAIL)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!class_exists('fw_photo_data')) {
    class fw_photo_data	{

		
		/**
		* PHP 4 Compatible Constructor
		*/
		function fw_photo_data(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){

		/*
		* Register the shortcode
		*/
		if ( function_exists( 'add_shortcode' ) ) {
			add_shortcode('photodata', array( &$this , 'photodata_shortcode_handler' ) );
		}
		

		}
		

		
		/**
		* photodata_shortcode_handler - produces and returns the content to replace the shortcode tag
		*
		* @param array $atts  An array of attributes passed from the shortcode
		* @param string $content   If the shortcode wraps round some html, this will be passed.
		*/
		function photodata_shortcode_handler( $atts , $content = null) {
			//add the attributes you want to accept to the array below
			$attributes = shortcode_atts(array(
		      'id' => 'none',
		      'url' => '',
			  'fail' => 'No data is available for this image.'
		      // ...etc
			), $atts);
		
			$return_value = $attributes['fail'];
		
			if ( $attributes['id'] == 'none' && !empty($attributes['url'])) {
				//get the attachment ID using the URL
				//the quickest and easiest way to get this is to go direct to the database
				
				$attachments = array_values(get_children("post_type=attachment&post_mime_type=image"));

				foreach($attachments as $attachment){
					
					if ( $attachment->guid == $attributes['url'] ) {
						$attributes['id'] = $attachment->ID;
						break;
					}
				}
			}
			
			if ( is_numeric( $attributes['id'] ) ) {
				
				//make sure we are dealing with an image
				if ( wp_attachment_is_image( $attributes['id'] ) ) {
					if ( $meta_data = wp_get_attachment_metadata( $attributes['id'] ) ) {
						foreach( $meta_data['image_meta'] as $key => $meta_item ){
							if ( !empty( $meta_item) && $meta_item != 'unknown' ) {
								if ( $key == 'created_timestamp' ){ $key = "Date Created"; $meta_item = date( "F j, Y, g:i a" , $meta_item); }
								$meta_list .= '<li>';
								$meta_list .= '<span class="meta_type">'.ucfirst(str_replace('_',' ',$key)).' - </span>'.$meta_item;
								$meta_list .= '</li>';
							}	
						}
						if ( !empty($meta_list) ) {
							$return_value = '<ul class="image_meta">';
							$return_value .= $meta_list .= '</ul>';
						}
					}
				}
			} 
				
		
			//return the content. DO NOT USE ECHO.
			return $return_value;
		}
		

    }
}

//instantiate the class
if (class_exists('fw_photo_data')) {
	$fw_photo_data = new fw_photo_data();
}




?>